import * as rt from "regular-table";
import { IContentRow } from "../content";
import { ContentsModel } from "../model";
import "../../style/grid";
declare const RegularTableElement: typeof rt.RegularTableElement;
export declare class TreeFinderGridElement<T extends IContentRow> extends RegularTableElement {
    init(model: ContentsModel<T>, options?: Partial<TreeFinderGridElement.IOptions<T>>): Promise<void>;
    dataListener(start_col: number, start_row: number, end_col: number, end_row: number): Promise<{
        num_columns: number;
        num_rows: number;
        column_headers: (keyof T)[][];
        row_headers: (string | HTMLSpanElement)[][];
        data: (string | T[keyof T])[][];
    }>;
    columnHeaderStyleListener(): void;
    rowStyleListener(): void;
    onRowClick(event: MouseEvent): Promise<void>;
    onSortClick(event: MouseEvent): Promise<void>;
    onTreeClick(event: MouseEvent): Promise<void>;
    onRowDoubleClick(event: MouseEvent): Promise<void>;
    protected get _pathRender(): "regular" | "relative" | "tree";
    protected options: TreeFinderGridElement.IOptions<T>;
    protected model: ContentsModel<T>;
    private _initializedListeners;
}
export declare namespace TreeFinderGridElement {
    interface IOptions<T extends IContentRow> {
        /**
         * if true, redraw the tree-finder element on window resize events
         */
        doWindowReize: boolean;
        /**
         * select from different strategies for rendcering the paths
         */
        pathRender: "regular" | "relative" | "tree";
        /**
         * if not null, the rendering of paths will change when any filter is set
         */
        pathRenderOnFilter: "regular" | "relative" | "tree";
    }
    function get(): typeof TreeFinderGridElement;
}
export {};
