import { IContentRow } from "../content";
import { ContentsModel } from "../model";
import { TreeFinderBreadcrumbsElement } from "./breadcrumbs";
import { TreeFinderFiltersElement } from "./filters";
import { TreeFinderGridElement } from "./grid";
import "../../style/panel";
export declare class TreeFinderPanelElement<T extends IContentRow> extends HTMLElement {
    connectedCallback(): void;
    clear(): void;
    init(root: T, options?: Partial<TreeFinderPanelElement.IOptions<T> & ContentsModel.IOptions<T> & TreeFinderGridElement.IOptions<T>>): Promise<void>;
    draw(): Promise<void>;
    create_shadow_dom(): void;
    protected shadowSheet: StyleSheet;
    protected breadcrumbsContainer: HTMLElement;
    protected filterContainer: HTMLElement;
    protected gridContainer: HTMLElement;
    protected breadcrumbs: TreeFinderBreadcrumbsElement<T>;
    protected filters: TreeFinderFiltersElement<T>;
    protected grid: TreeFinderGridElement<T>;
    protected options: TreeFinderPanelElement.IOptions<T>;
    protected model: ContentsModel<T>;
    private _initialized;
}
export declare namespace TreeFinderPanelElement {
    interface IOptions<T extends IContentRow> {
        openChildren: boolean;
    }
    function get(): typeof TreeFinderPanelElement;
}
