import { MetaData, RegularTableElement } from "regular-table";
export declare namespace RegularTable {
    function cellClicked(metadata: MetaData): boolean;
    function columnHeaderClicked(metadata: MetaData): boolean;
    function rowClicked(metadata: MetaData): boolean;
    function rowHeaderClicked(metadata: MetaData): boolean;
    function clickLoggingListener(event: MouseEvent, rt: RegularTableElement): void;
    function metadataFromElement(target: HTMLElement, rt: RegularTableElement, recursive?: boolean): MetaData | undefined;
}
export declare namespace String {
    /**
     * remove all back/slashes from string
     */
    function trimSlash(x: string): string;
    /**
     * remove all back/slashes, then add a trailing slash if requested to a string
     */
    function normSlash(x: string, trailing: boolean): string;
}
export declare namespace Tag {
    const html: (strings: TemplateStringsArray, ...args: any[]) => string;
}
export declare namespace Tree {
    function rowHeaderSpan({ isDir, isOpen, path, pathRender }: {
        isDir: boolean;
        isOpen: boolean;
        path: string[];
        pathRender?: "regular" | "relative" | "tree";
    }): (string | HTMLSpanElement)[];
    function breadcrumbsSpans(path: string[]): string;
}
